#ifndef GAUGEHORIZON_H
#define GAUGEHORIZON_H
#include "gauge.h"

class GaugeHorizon : public Gauge
{
    Q_OBJECT
    Q_PROPERTY(QColor horizonGroundColor READ getHorizonGroundColor WRITE setHorizonGroundColor)
    Q_PROPERTY(QColor horizonSkyColor READ getHorizonSkyColor WRITE setHorizonSkyColor)
    Q_PROPERTY(QColor horizonLineColor READ getHorizonLineColor WRITE setHorizonLineColor)
public:
    explicit GaugeHorizon(QGraphicsItem *parent = 0);
    void paint(QPainter *painter,const QStyleOptionGraphicsItem *option,
                               QWidget *widget);
    void drawHorizon(QPainter *painter,float pitch,float roll);
    void setHorizonSkyColor(QColor val_) { m_horizonSkyColor=val_;};
    QColor getHorizonSkyColor() {return m_horizonSkyColor;};
    void setHorizonLineColor(QColor val_) { m_horizonLineColor=val_;};
    QColor getHorizonLineColor() {return m_horizonLineColor;};
    void setHorizonGroundColor(QColor val_) { m_horizonGroundColor=val_;};
    QColor getHorizonGroundColor() {return m_horizonGroundColor;};
private:
    QColor m_horizonLineColor;
    QColor m_horizonSkyColor;
    QColor m_horizonGroundColor;
    QVector<QLine>  fixo;
    QPolygon plane,planel,planer;
    QPolygon zeroTriangle;
    QPolygon angleTriangle;
signals:
};

#endif // GAUGEHORIZON_H
